Graphics 640,480,32,2

SetBuffer BackBuffer()

Const CellSize = 32

SeedRnd MilliSecs()

Global Index = 0
Global Counter = 0
Global CounterStopped = False
Global PlayerX = 304
Global PlayerY = 400

Global Pic0 = LoadImage("tile0.bmp")
Global Pic1 = LoadImage("tile1.bmp")
Global Pic2 = LoadImage("tile2.bmp")
Global Player = LoadImage("ship1.bmp")
Global Enemy = LoadImage("target.bmp")
Global Bang = LoadAnimImage("exp1.bmp",32,32,0,4)

Global snd1 = LoadSound("exp01.wav")
Global snd2 = LoadSound("exp02.wav")

Dim Map(19,19)
InitMap()


While Not KeyHit(1)
	
	Cls

	If Not CounterStopped Then
		Counter = (Counter + 1) Mod 32
		If counter = 0 Then
			Index = Index + 1
		EndIf
	EndIf
	
	DrawGrid(20, 16, Counter)
	
	DrawImage Enemy,308,100
	
	DrawPlayer()
	
	Flip
	
Wend

FreeImage Pic0
FreeImage Pic1
FreeImage Pic2
FreeImage Player
FreeImage Enemy
FreeImage Bang

FreeSound snd1
FreeSound snd2

End


;


Function DrawGrid(cols, rows, offset)
	
	For j = 0 To (rows - 1)
		For i = 0 To (cols - 1)
			XIndex# = i
			YIndex# = Index - j + 15
			XPos = (i * CellSize)
			YPos = (j * CellSize) + (offset - 32)
			Select Map(XIndex,YIndex Mod 19)
				Case 0
					DrawImage Pic0, XPos, YPos
				Case 1
					DrawImage Pic1, XPos, YPos
				Case 2
					DrawImage Pic2, XPos, YPos
			End Select
			;Rect XPos, YPos, (CellSize + 1), (CellSize + 1), 0
		Next
	Next
	
End Function


Function DrawPlayer()

	MaskImage Player,255,255,255
	MaskImage Bang,255,255,255
	
	DrawImage Player,PlayerX,PlayerY

	If MouseDown(1) Then
		TargetX = MouseX()
		TargetY = MouseY()
		If (Counter Mod 4) = 0 Then
			Line PlayerX+16, PlayerY+16, TargetX, TargetY
		EndIf
		If Abs(TargetX - 320) < 10 And Abs(TargetY - 104) < 10 Then
			DrawImage Bang,304,90,(Counter Mod 8)/2
			If (Counter Mod 16) = 0 Then
				StopChannel ch1
				ch1 = PlaySound(snd1)
			EndIf
		ElseIf (Counter Mod 8) = 0 Then
			StopChannel ch1
			ch1 = PlaySound(snd2)
		EndIf
	EndIf

	If KeyDown(57) Then		;space
		If (Counter Mod 4) = 0 Then
			Line PlayerX+8, PlayerY+8, PlayerX+8, 0
		ElseIf (Counter Mod 4) = 2 Then
			Line PlayerX+23, PlayerY+8, PlayerX+23, 0
		EndIf
		If ImageRectOverlap (Enemy, 308, 100, PlayerX + 8, 0, 15, PlayerY)
			DrawImage Bang,304,90,(Counter Mod 8)/2
			If (Counter Mod 16) = 0 Then
				StopChannel ch1
				ch1 = PlaySound(snd1)
			EndIf
		ElseIf (Counter Mod 8) = 0 Then
			StopChannel ch1
			ch1 = PlaySound(snd2)
		EndIf
	EndIf
		
	If KeyDown(203) Then	; left
		PlayerX = PlayerX - 2
		If PlayerX < 0 Then PlayerX = 0
	EndIf
	
	If KeyDown(205) Then	; right
		PlayerX = PlayerX + 2
		If PlayerX > 608 Then PlayerX = 608
	EndIf
	
	If KeyDown(200) Then	; up
		PlayerY = PlayerY - 2
		If PlayerY < 0 Then PlayerY = 0
	EndIf
	
	If KeyDown(208) Then	; down
		PlayerY = PlayerY + 2
		If PlayerY > 448 Then PlayerY = 448
	EndIf
	
	;dummy code for springing player to idle position
	If (Counter Mod 4) = 0 Then
		DiffX = PlayerX - 304
		If DiffX < 0 Then
			PlayerX = PlayerX + 1
		ElseIf DiffX > 0 Then
			PlayerX = PlayerX - 1
		EndIf
		DiffY = PlayerY - 400
		If DiffY < 0 Then
			PlayerY = PlayerY + 1
		ElseIf DiffY > 0 Then
			PlayerY = PlayerY - 1
		EndIf
	EndIf

End Function


Function InitMap()

	For j = 0 To 19
		For i = 0 To 19
			Map(i,j) = Rand(0,2)
		Next
	Next
End Function


;